﻿Option Strict On

Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports System.Xml

Public Class CalendarViewModel
    Implements INotifyPropertyChanged



    Public Sub New()
        Day = New ObservableCollection(Of DayVm)


        Dim appPath As String = My.Application.Info.DirectoryPath

        For Each f In IO.Directory.GetFiles($"{appPath}\XML\")
            Dim xmlReader As XmlReader
            xmlReader = XmlReader.Create(f)

            Dim xmlDoc = New XmlDocument()
            xmlDoc.Load(xmlReader)

            GetDataFromXML(IO.Path.GetFileNameWithoutExtension(f), xmlDoc)
        Next

    End Sub



    Private _day As ObservableCollection(Of DayVm)
    Public Property Day() As ObservableCollection(Of DayVm)
        Get
            Return _day
        End Get
        Set(ByVal value As ObservableCollection(Of DayVm))
            _day = value
            RaisePropertyChanged()
        End Set
    End Property











    Private Sub GetDataFromXML(mPerson As String, mNode As XmlNode, Optional mDay As DayVm = Nothing)

        If TypeOf mNode Is XmlComment Then

            If mNode.HasChildNodes Then GetDataFromXML(mPerson, mNode.FirstChild, mDay)


        ElseIf TypeOf mNode Is XmlDocument Then

            If mNode.HasChildNodes And (TypeOf mNode.FirstChild Is XmlText) Then
                Debug.WriteLine("XMLElement - " & mNode.Name & "=""" & mNode.FirstChild.Value & """")
            Else
                Debug.WriteLine("XMLElement - " & mNode.Name)
                GetDataFromXML(mPerson, mNode.LastChild, Nothing)
            End If
        ElseIf TypeOf mNode Is XmlElement Then


            Dim mItem As New DayVm With {.Person = mPerson, .Appointments = New ObservableCollection(Of AppointmentVm)}

            If mNode.Name = "Daten" Then
                For Each cn As XmlNode In mNode.ChildNodes
                    GetDataFromXML(mPerson, cn)
                Next
            Else



                If DirectCast(mNode, XmlElement).Name = "Eintrag" Then
                    If DirectCast(mNode, XmlElement).HasAttributes Then


                        Day.Add(mItem)

                        For Each xmlAttribute As XmlNode In DirectCast(mNode, XmlElement).Attributes
                            With xmlAttribute
                                If .Name = "ID" Then
                                    mItem.TheDate = CDate(.Value)
                                Else
                                    Debug.WriteLine("!! - An unknown attribute in XMLNode " & .Name & " with value '" & .Value & "' found!!!!!")
                                End If
                            End With
                        Next

                        If mNode.FirstChild.Name = "Zelltext" Then
                            For Each n As XmlNode In mNode.ChildNodes
                                mItem.Appointments.Add(New AppointmentVm() With {.Title = n.InnerText})
                            Next
                        End If


                    End If

                End If

                If mNode.HasChildNodes Then
                    For Each cn As XmlNode In mNode.ChildNodes
                        GetDataFromXML(mPerson, cn, mItem)
                    Next
                End If
            End If




        End If


    End Sub






    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        If prop IsNot Nothing AndAlso prop.Length > 0 Then RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub


    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
